Loading...
Searching...
No Matches
Sip_min_expires

## Data Structures

struct | sip_min_expires_s
| Structure for Min-Expires header. More...

## Macros

#define | sip_min_expires(sip)
| Access a SIP Min-Expires header structure sip_min_expires_t from sip_t.
#define | SIP_MIN_EXPIRES_INIT()
| Initializer for structure sip_min_expires_t.
#define | SIPTAG_MIN_EXPIRES(x)
| Tag list item for pointer to a Min-Expires header structure sip_min_expires_t.
#define | SIPTAG_MIN_EXPIRES_REF(x)
| Tag list item for reference to a Min-Expires header pointer.
#define | SIPTAG_MIN_EXPIRES_STR(s)
| Tag list item for string with Min-Expires header value.
#define | SIPTAG_MIN_EXPIRES_STR_REF(x)
| Tag list item for reference to a Min-Expires header string.

## Typedefs

typedef struct sip_min_expires_s | sip_min_expires_t
| @

## Functions

issize_t | sip_min_expires_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Min-Expires header.
issize_t | sip_min_expires_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Min-Expires header.
sip_min_expires_t * | sip_min_expires_init (sip_min_expires_t x[1])
| Initialize a structure sip_min_expires_t.
int | sip_is_min_expires (sip_header_t const *header)
| Test if header object is instance of sip_min_expires_t.
sip_min_expires_t * | sip_min_expires_dup (su_home_t *home, sip_min_expires_t const *hdr))
| Duplicate a list of Min-Expires header header structures sip_min_expires_t.
sip_min_expires_t * | sip_min_expires_copy (su_home_t *home, sip_min_expires_t const *hdr))
| Copy a list of Min-Expires header header structures sip_min_expires_t.
sip_min_expires_t * | sip_min_expires_make (su_home_t *home, char const *s))
| Make a Min-Expires header structure sip_min_expires_t.
sip_min_expires_t * | sip_min_expires_format (su_home_t *home, char const *fmt,...)))
| Make a Min-Expires header from formatting result.

## Variables

msg_hclass_t | sip_min_expires_class []
| Header class for Min-Expires header.
tag_typedef_t | siptag_min_expires
| Tag for Min-Expires header object.
tag_typedef_t | siptag_min_expires_str
| Tag for string with Min-Expires header value.

## Detailed Description

## Macro Definition Documentation

## SIP_MIN_EXPIRES_INIT

#define SIP_MIN_EXPIRES_INIT | ( |  | ) |

Initializer for structure sip_min_expires_t.

A static sip_min_expires_t structure for Min-Expires header must be initialized with the SIP_MIN_EXPIRES_INIT() macro. For instance,

sip_min_expires_t sip_min_expires = SIP_MIN_EXPIRES_INIT;
sip_min_expires
#define sip_min_expires(sip)
Access a SIP Min-Expires header structure sip_min_expires_t from sip_t.
Definition sip_protos.h:5129
SIP_MIN_EXPIRES_INIT
#define SIP_MIN_EXPIRES_INIT()
Initializer for structure sip_min_expires_t.
Definition sip_protos.h:5146
sip_min_expires_t
struct sip_min_expires_s sip_min_expires_t
@
Definition sip.h:163

## SIPTAG_MIN_EXPIRES

#define SIPTAG_MIN_EXPIRES | ( |  | x | ) |

Tag list item for pointer to a Min-Expires header structure sip_min_expires_t.

The SIPTAG_MIN_EXPIRES() macro is used to include a tag item with a pointer to a sip_min_expires_t structure in a tag list.

Parameters

  x | pointer to a sip_min_expires_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_MIN_EXPIRES_REF().

## SIPTAG_MIN_EXPIRES_STR

#define SIPTAG_MIN_EXPIRES_STR | ( |  | s | ) |

Tag list item for string with Min-Expires header value.

The SIPTAG_MIN_EXPIRES_STR() macro is used to include a tag item with a string containing value of a sip_min_expires_t header in a tag list.

Parameters

  s | pointer to a string containing Min-Expires header value, or NULL.

The string in SIPTAG_MIN_EXPIRES_STR() can be converted to a sip_min_expires_t header structure by giving the string s has second argument to function sip_min_expires_make().

The corresponding tag taking reference parameter is SIPTAG_MIN_EXPIRES_STR_REF().

## Typedef Documentation

## sip_min_expires_t

typedef struct sip_min_expires_s sip_min_expires_t

@

The Min-Expires header is used to limit the number of proxies or gateways that can forward the request. The Min-Expires syntax is defined in RFC 3261 as follows:

Min-Expires = "Min-Expires" HCOLON delta-seconds

The parsed Min-Expires header is stored in sip_min_expires_t structure.

The structure sip_min_expires_t contains representation of SIP Min-Expires header.

The sip_min_expires_t is defined as follows:

typedef struct sip_min_expires_s {
sip_common_t me_common[1]; // Common fragment info
sip_error_t *me_next; // Link to next (dummy)
unsigned long me_delta; // Seconds
} sip_min_expires_t;
sip_error_t
msg_error_t sip_error_t
@
Definition sip.h:134
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_min_expires_s
Structure for Min-Expires header.
Definition sip.h:569
sip_min_expires_s::me_common
sip_common_t me_common[1]
Common fragment info.
Definition sip.h:570
sip_min_expires_s::me_delta
unsigned long me_delta
Seconds.
Definition sip.h:572
sip_min_expires_s::me_next
sip_error_t * me_next
Link to next (dummy).
Definition sip.h:571

## Function Documentation

## sip_is_min_expires()

int sip_is_min_expires | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_min_expires_t.

Check if the header class is an instance of Min-Expires header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header min_expires
  0 | (false) otherwise

## sip_min_expires_copy()

sip_min_expires_t * sip_min_expires_copy | ( | su_home_t * | home,
|  | sip_min_expires_t const * | hdr )

inline

Copy a list of Min-Expires header header structures sip_min_expires_t.

The function sip_min_expires_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  min_expires = sip_min_expires_copy(home, sip->sip_min_expires);
  sip_min_expires_copy
  sip_min_expires_t * sip_min_expires_copy(su_home_t *home, sip_min_expires_t const *hdr))
  Copy a list of Min-Expires header header structures sip_min_expires_t.
  Definition sip_protos.h:5276

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_min_expires_dup()

sip_min_expires_t * sip_min_expires_dup | ( | su_home_t * | home,
|  | sip_min_expires_t const * | hdr )

inline

Duplicate a list of Min-Expires header header structures sip_min_expires_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  min_expires = sip_min_expires_dup(home, sip->sip_min_expires);
  sip_min_expires_dup
  sip_min_expires_t * sip_min_expires_dup(su_home_t *home, sip_min_expires_t const *hdr))
  Duplicate a list of Min-Expires header header structures sip_min_expires_t.
  Definition sip_protos.h:5233

Returns
  A pointer to the newly duplicated sip_min_expires_t header structure, or NULL upon an error.

## sip_min_expires_format()

sip_min_expires_t * sip_min_expires_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Min-Expires header from formatting result.

Make a new sip_min_expires_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_min_expires_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_min_expires_init()

sip_min_expires_t * sip_min_expires_init | ( | sip_min_expires_t | x[1] | ) |

inline

Initialize a structure sip_min_expires_t.

An sip_min_expires_t structure for Min-Expires header can be initialized with the sip_min_expires_init() function/macro. For instance,

sip_min_expires_t sip_min_expires;
sip_min_expires_init(&sip_min_expires);
sip_min_expires_init
sip_min_expires_t * sip_min_expires_init(sip_min_expires_t x[1])
Initialize a structure sip_min_expires_t.
Definition sip_protos.h:5164

## sip_min_expires_make()

sip_min_expires_t * sip_min_expires_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Min-Expires header structure sip_min_expires_t.

The function sip_min_expires_make() makes a new sip_min_expires_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_min_expires_t header structure, or NULL upon an error.

## Variable Documentation

## sip_min_expires_class

msg_hclass_t sip_min_expires_class[]

extern

Header class for Min-Expires header.

The header class sip_min_expires_class defines how a SIP Min-Expires header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_min_expires_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.